﻿#Requires AutoHotkey v2.0
SendMode "Input"
SetKeyDelay -1

; initialize Canned Message Gui 
; Variables ==================================================
CMGTi := "Canned Message GUI"
CMGVe := "1.1810.12"

DpreTrig := ".."             ; tooltip trigger
DTrSepDe := " ,,,"           ; filename separator trigger and description
DDescEnd := ""               ; filename description ender
DFolderName := "msg"         ; folder to store canned message

preTrig := IniRead(".\setting.ini", "A", "aktivasi", DpreTrig)
TrSepDe := IniRead(".\setting.ini", "A", "pemisah", DTrSepDe)
DescEnd := IniRead(".\setting.ini", "A", "akhiran", DDescEnd)
FolderName := IniRead(".\setting.ini", "A", "namafolder", DFolderName)

LePrTr := StrLen(preTrig)   ; preTrigger character count
ArTrig := []                ; trigger text array
ArDesc := []                ; Description text array
ArText := []                ; canned message text array
StTrig := ""                ; strings to check with "|" separator
AutoFill := 0               ; false, setting to autofill text if gui lose focus
AutoFillMinCount := 2       ; minimal text string after "space"
Active := 0                 ; false, setting to invoke hot if
outString := ""             ; word to output
Selected := 1               ; cursor position for selecting, 1 is top
stringTe := ""              ; last word in log separated with space
tex := ""                   ; to store live keypress log
onlyone := true             ; setting to auto trigger if only one choice
AppMode := "otomatis"       ; initial setting

pretexA := "Aktivasi: " preTrig "    |   "
pretexM := "Mode: " AppMode
pretexL := "   |   Keyboard Log:"
CMGid := 0                  ; unique ID number (HWND) of CMG
CMGX := 0                   ; Canned Message Gui X position
CMGY := 0                   ; Canned Message Gui Y position
BTAX := 0                   ; Array Trigger Add button X position
BTAY := 0                   ; Array Trigger Add button Y position
BTCX := 0                   ; Array Trigger Clipboard button X position
BTCY := 0                   ; Array Trigger Clipboard button Y position
CMGW := 0                   ; Canned Message Gui Width size
CMGH := 0                   ; Canned Message Gui Height size
CMLW := 0                   ; Canned Message Key Log Width size
ATLH := 0                   ; Array Trigger List Height size
ATDW := 0                   ; Array Trigger Description Width size
ATTH := 0                   ; Array Trigger Text Height size
ATTW := 0                   ; Array Trigger Text Width size
CMGXn := 0                  ; Canned Message Gui X temp position
CMGYn := 0                  ; Canned Message Gui Y temp position
CMGWn := 0                  ; Canned Message Gui Width temp position
CMGHn := 0                  ; Canned Message Gui Height temp position
oCMLW := 320                ; Original Canned Message Key Log Width size
oATLH := 200                ; Original Array Trigger List Height size
oATLW := 50                 ; Original Array Trigger List Width size
oBTSi := 50                 ; Original Button Width size
iATS := "Pemicu"            ; Initial Array Trigger String
iATD := "Deskripsi"         ; Initial Array Trigger Description
iATT := "Hasil Tulisan`r`n`r`n" FileRead(".\manual.txt")

; Creating Folder For Canned Message =========================
if not DirExist(".\" FolderName) 
{
    DirCreate ".\" FolderName
}
FileAppend ClipboardAll(), "./temp.clip" ; The file extension does not matter.

; Initialize Trigger and Content Array =======================
list_files(".\" FolderName)

; Set List Width Based on Content Array ======================
oATLW := GuiObjWidth(ArTrig, oATLW)

; to log keys ================================================
MCR_StartRecord()

; String Text ================================================
Loop ArTrig.Length 
{
    StTrig .= "|" preTrig ArTrig[ A_Index ]
}

; Show Log GUI ===============================================
CMG := Gui( "+Resize +AlwaysOnTop +MinSize320x240", CMGTi " v" CMGVe )
CMGm := CMG.MarginY

CMPA := CMG.Add("Text", "vTexRecA Section", pretexA)
CMPM := CMG.Add("Text", "vTexRecM X+" CMGm, pretexM)
CMPM.Text := "manual"
CMPL := CMG.Add("Text", "vTexRecL X+" CMGm, pretexL)
CML := CMG.Add("Edit", "vCaMassLog ReadOnly Right XS W" oCMLW, tex)
CML.GetPos( , , , &CMLH)

ATL := CMG.Add("ListBox", "vArTrigList 0x100 H" oATLH " W" oATLW, ArTrig)
ATS := CMG.Add("Edit", "vArTrigStri r1 YP WP Section", iATS)
ATD := CMG.Add("Edit", "vArTrigDesc r1 YP W" oCMLW - ((2 * CMGm) + (2 * oATLW)), iATD)
ATT := CMG.Add("Edit", "vArTrigText H" oATLH - ((2 * CMGm) + (2 * CMLH) + 1) " W" (oCMLW - ((2 * CMGm) + (2 * oATLW))) + CMGm + oATLW " XS", iATT)

BTA := CMG.Add("Button", "vBuTrigAdd W" oBTSi " XS" (oCMLW - ((2 * CMGm) + (2 * oBTSi) + oATLW) + 1), "&Add")
BTC := CMG.Add("Button", "vBuTrigCli W" oBTSi " Default X+" CMGm, "&Copy")

CMG.Show()

CMG.GetPos(&CMGX, &CMGY, &CMGW, &CMGH)
ATL.GetPos( , , , &ATLH)
ATD.GetPos( , , &ATDW, )
CML.GetPos( , , &CMLW, )
ATT.GetPos( , , &ATTW, &ATTH)
BTA.GetPos(&BTAX, &BTAY, , )
BTC.GetPos(&BTCX, &BTCY, , )

CMG.OnEvent("Size", Gui_Size)
CMG.OnEvent("Close", guiOnClose)
ATS.OnEvent("Change", AddTrigger)
ATD.OnEvent("Change", AddTrigger)
ATT.OnEvent("Change", AddTrigger)
BTA.OnEvent("Click", BTA_Click)     ; Call BTA_Click when clicked.
BTC.OnEvent("Click", BTC_Click)     ; Call BTC_Click when clicked.

CML.OnEvent("Focus", Gui_Resettex)
CML.OnEvent("LoseFocus", Gui_Resettex)

ATL.OnEvent("Focus", Gui_CheckFocus)
ATS.OnEvent("Focus", Gui_CheckFocus)
ATD.OnEvent("Focus", Gui_CheckFocus)
ATT.OnEvent("Focus", Gui_CheckFocus)
BTA.OnEvent("Focus", Gui_CheckFocus)
BTC.OnEvent("Focus", Gui_CheckFocus)

ATL.OnEvent("LoseFocus", Gui_CheckFocus)
ATS.OnEvent("LoseFocus", Gui_CheckFocus)
ATD.OnEvent("LoseFocus", Gui_CheckFocus)
ATT.OnEvent("LoseFocus", Gui_CheckFocus)
BTA.OnEvent("LoseFocus", Gui_CheckFocus)
BTC.OnEvent("LoseFocus", Gui_CheckFocus)

ATL.OnEvent("Change", Gui_ListClick)
ATL.OnEvent("DoubleClick", Gui_ListDbClick)

Gui_Resettex()
; Closing App ================================================
GuiClose:
GuiContextMenu:
*ESC::ExitApp

; Start Monitoring ===========================================
;SetTimer WatchControl, 30

; Additional Control =========================================
#HotIf ( Active )
    Down::
    {
        global Selected
        if( ATL.Value = 0 )
        {
            Selected := 1
        }
        if( ATL.Value != 0 )
        {
            Selected := ++Selected > ArTrig.Length ? ArTrig.Length : Selected
        }
        ATL.Choose ( Selected )
        Gui_ListClick() 
    }
    Up::
    {
        global Selected := --Selected < 1 ? 1 : Selected
        ATL.Choose ( Selected )
        Gui_ListClick() 
    }
    Space::
    Enter::
    Right::
    {
        global tex
        global FolderName
        global AutoFill
        global outString
        tex .= " "
        if( AutoFill ) 
        {
            Sleep 30
            Send "^+{left}"
            sleep 50
            ClipSave()
            sleep 50
        }
        A_Clipboard := outString
        if( AutoFill ) 
        {
            sleep 50
            Send "^v"
            sleep 50
            ClipRes()
        }
        CML.Text := tex
        ResetGUI()
        outString := ""
        Active := 0
    }
    Left::
    {
;        A_Clipboard := StTrig
        global Selected := 1
        ATL.Choose ( Selected )
        Gui_ListClick() 
    }
#HotIf

; Functions ==================================================
WatchControl() 
{
    ; variables ----------------------------------------------
    global Selected     ; selected word
    global stringTe     ; last word logged
    global StTrig       ; all trigger text in one string with pretrig
    global outString    ; canned text message to produce
    global ArTrig       ; array to store trigger string
    global Active       ; 0 = false, setting to invoke hot if
    global tex          ; logged text from current proc
    global LePrTr       ; preTrigger character count
    
    ; separate logged text typed -----------------------------
    stringAr := StrSplit( tex, " " )

    ; save into stringTe -------------------------------------
    stringTe := ""
    if( stringAr.Length > 0 ) 
    {
        stringTe := stringAr[ stringAr.Length ]
        LenStTe := StrLen(stringTe)
    }

    ; if last word not empty, exist in trigger string --------
    if( stringTe != "" 
        && InStr( StTrig, "|" stringTe ) 
        && AutoFill
        && LenStTe > LePrTr ) 
    {
        ; reset list -----------------------------------------
        ATL.Delete()
        ListCount := 0
        ; reset text -----------------------------------------
        ATS.Text := iATS
        ATD.Text := iATD
        ATT.Text := iATT
        iL := 0
        ; logged character count without pre trigger ---------
        logNoPre := LenStTe - LePrTr
        ; exclude pretrigger from logged text ----------------
        curstTe := SubStr(stringTe, 1 + LePrTr, logNoPre )
        ; loop through trigger array -------------------------
        Loop ArTrig.Length 
        {
            ; current trigger in array -----------------------
            curTrig := ArTrig[ A_Index ]
            ; if logged text exist in current trigger --------
            if( InStr( curTrig, curstTe ) 
                && subStr( curTrig, 1, logNoPre ) = curstTe ) 
            {
                ; if currently chosen ------------------------
                if( Selected = ListCount + 1 ) 
                {
                    ATS.Text := ArTrig[ A_Index ]
                    ATD.Text := ArDesc[ A_Index ]
                    ATT.Text := ArText[ A_Index ]
                    outString := ArText[ A_Index ]
                }
                ATL.Add( [ ArTrig[ A_Index ] ] )
                ListCount++
            }
        }
        
        ; if the trigger only have 1 choice ------------------
        if( StrLen( stringTe ) >= AutoFillMinCount 
            && AutoFill
            && ListCount = 1 
            && onlyone) 
        {
            tex .= " "
            Sleep 30
            Send "^+{left}"
            sleep 50
            ClipSave()
            sleep 50
            A_Clipboard := outString
            sleep 50
            Send "^v"
            sleep 50
            ClipRes()
            CML.Text := tex
            ResetGUI()
            outString := ""
            return
        }
        Active := 1
        if( Selected > ListCount )
            Selected := ListCount
            
    } else 
    {
        Selected := 1
        Active := 0
    }
}

MCR_StartRecord() 
{
    static ih

    if !IsSet(ih) 
    {
        ih := InputHook("V L0")        ; create InputHook object
        ih.KeyOpt("{All}", "N")     ; enable notification for all keys
        ih.KeyOpt("{LShift}{RShift}{LAlt}{RAlt}{LControl}{RControl}", "-N")
        ih.KeyOpt("{LWin}{RWin}{Tab}{PrintScreen}{Pause}{Break}", "-N")
        ih.KeyOpt("{Enter}", "-N")
        ih.KeysDown := Map()        ; I created this property to remember what key is already down
        ih.OnKeyDown := MCR_KeyDown ; call this function when key is pressed
        ih.OnKeyUp := MCR_KeyUp     ; call this function when key is released
    }

    if ih.InProgress 
    {
        ih.Stop() ; stop input hook if it's in progress
    } else 
    {
        ih.Start() ; start input hook if it's not in progress
    }
}

; this function is called when key is down
MCR_KeyDown(ih, VK, SC) 
{
    ; get the key name from VK and SC
    global tex
    
    key := GetKeyName(Format("vk{:x}sc{:x}", VK, SC))

    ; prevent the key from repeatedly calling the function when the key is down
    if !ih.KeysDown.Get(key, "")
        ih.KeysDown[key] := 1
    else
        return    
        
    ; special keys ifs
    Switch key
    {
    Case "Space":
        tex .=  " "
    Case "Numpad1":
        tex .=  "1"
    Case "Numpad2":
        tex .=  "2"
    Case "Numpad3":
        tex .=  "3"
    Case "Numpad4":
        tex .=  "4"
    Case "Numpad5":
        tex .=  "5"
    Case "Numpad6":
        tex .=  "6"
    Case "Numpad7":
        tex .=  "7"
    Case "Numpad8":
        tex .=  "8"
    Case "Numpad9":
        tex .=  "9"
    Case "Numpad0":
        tex .=  "0"
    Case "Backspace":
        key := ""
        texlen := StrLen(tex)-1
        tex := SubStr(tex, 1, texlen)
    Case "Enter":
        tex := ""
    Case "PgDn", "PgUp", "Up", "Down", "Right", "Left", "Delete", "End", "Home", "ScrollLock", "Numlock":
        key := ""
    Default:
        tex .= key
    }

    ; checking how long the recorded string is, can be combined with SubStr to limit character recording.
    if StrLen(tex) > 50 
    {
        ; place code if length qualified
        tex :=  SubStr(tex, -50)
    }
    CML.Text := tex
    WatchControl()
}

MCR_KeyUp(ih, VK, SC) 
{
    key := GetKeyName(Format("vk{:x}sc{:x}", VK, SC))
    ih.KeysDown[key] := 0
    WatchControl()
}

guiOnClose(*) 
{
    ExitApp
}

list_files(Directory)
{
    global TrSepDe
    global DescEnd
    files := ""
    Loop Files, Directory "\*.*", "R"
    {
        tempnm := StrReplace(A_LoopFileName, "." A_LoopFileExt)
        FiDe := InStr(tempnm, TrSepDe)
        LeNm := StrLen(tempnm)
        LeSe := StrLen(TrSepDe)
        LeEn := StrLen(DescEnd)
        temptr := SubStr(tempnm, 1, FiDe - 1)
        tempde := SubStr(tempnm, FiDe + LeSe, LeNm - ((FiDe - 1) + LeSe + LeEn))
        tempco := FileRead(A_LoopFileFullPath)
        ArTrig.Push(temptr)
        ArDesc.Push(tempde)
        ArText.Push(tempco)
        files := files " `n" tempnm
    }
    return files
}

ClipSave()
{
    global FolderName
    ; Option 1: Delete any existing file and then use FileAppend.
    FileDelete "./temp.clip"
    FileAppend ClipboardAll(), "./temp.clip" ; The file extension does not matter.
}

ClipRes()
{
    global FolderName
    ; Option 2: Use FileOpen in overwrite mode and File.RawWrite.
    ClipData := FileRead("./temp.clip", "RAW")  ; In this case, FileRead returns a Buffer.
    A_Clipboard := ClipboardAll(ClipData)  ; Convert the Buffer to a ClipboardAll and assign it.
}

AddTrigger(*) 
{
    BTA.Text := "&Save"
    if( InStr( StTrig, ATS.Text "|" ) = false && StrLen( ATS.Text ) > 1 )
    {
        BTA.Text := "&Add"
    }
}

Gui_Size(GuiObj, MinMax, Width, Height) 
{
    global CMGX             ; Canned Message Gui X position
    global CMGY             ; Canned Message Gui Y position
    global CMGW             ; Canned Message Gui Width size
    global CMGH             ; Canned Message Gui Height size
    global CMGXn            ; Canned Message Gui X temp position
    global CMGYn            ; Canned Message Gui Y temp position
    global CMGWn            ; Canned Message Gui Width temp position
    global CMGHn            ; Canned Message Gui Height temp position
    global CMLW             ; Canned Message Key Log Width size
    global ATLH             ; Array Trigger List Height size
    global ATDW             ; Array Trigger Description Width size
    global ATTH             ; Array Trigger Text Height size
    global ATTW             ; Array Trigger Text Width size
    global BTAX             ; Array Trigger Add button X position
    global BTAY             ; Array Trigger Add button Y position
    global BTCX             ; Array Trigger Clipboard button X position
    global BTCY             ; Array Trigger Clipboard button Y position
    If (MinMax != -1) ; if the window has not been minimized, resize the control.
    {
        CMG.GetPos(&CMGXn, &CMGYn, &CMGWn, &CMGHn)
        ATL.Move(, , , ATLH + ( CMGHn - CMGH ))
        ATL.Redraw()
        ATD.Move(, , ATDW + ( CMGWn - CMGW ), )
        ATD.Redraw()
        CML.Move(, , CMLW + ( CMGWn - CMGW ), )
        CML.Redraw()
        ATT.Move(, , ATTW + ( CMGWn - CMGW ), ATTH + ( CMGHn - CMGH ))
        ATT.Redraw()
        BTA.Move(BTAX + ( CMGWn - CMGW ), BTAY + ( CMGHn - CMGH ), , )
        BTA.Redraw()
        BTC.Move(BTCX + ( CMGWn - CMGW ), BTCY + ( CMGHn - CMGH ), , )
        BTC.Redraw()
        CMGX := CMGXn
        CMGY := CMGYn
        CMGW := CMGWn
        CMGH := CMGHn
        ATL.GetPos( , , , &ATLH)
        ATD.GetPos( , , &ATDW, )
        CML.GetPos( , , &CMLW, )
        ATT.GetPos( , , &ATTW, &ATTH)
        BTA.GetPos(&BTAX, &BTAY, , )
        BTC.GetPos(&BTCX, &BTCY, , )
    }
}

BTA_Click(*) 
{
    global TrSepDe
    global FolderName
    global StTrig
    global ArTrig
    global ArDesc
    global ArText
    global preTrig
    
    if( BTA.Text := "&Save" )
    {
        Loop ArTrig.Length 
        {
            if( ArTrig[ A_Index ] = ATS.Text ) 
            {
                FileDelete ".\" FolderName "\" ATS.Text TrSepDe ArDesc[ A_Index ] ".txt"
                ArDesc[ A_Index ] := ATD.Text
                ArText[ A_Index ] := ATT.Text
                Break
            }
        }
    }
    
    FileAppend ATT.Text, ".\" FolderName "\" ATS.Text TrSepDe ATD.Text ".txt"
    
    if( BTA.Text := "&Add" )
    {
        ArTrig := []                ; trigger text array
        ArDesc := []                ; Description text array
        ArText := []                ; canned message text array
        StTrig := ""                ; strings to check with "|" separator
        list_files(".\" FolderName)
        Loop ArTrig.Length 
        {
            StTrig .= "|" preTrig ArTrig[ A_Index ]
        }
        ResetGUI()
    }
    AddTrigger()
}

ResetGUI()
{
    global Selected
    global ArTrig
    global iATS
    global iATD
    global iATT
    ATL.Delete()
    ATL.Add( ArTrig )
    ATL.Choose( 0 )
    ATS.Text := iATS
    ATD.Text := iATD
    ATT.Text := iATT
    AddTrigger()
    Selected := 1
}

ClipTooltip()
{
    global CMGm
    ToolTip "Hasil Tulisan sudah disalin ke Clipboard.`nSilakan gunakan Ctrl+V untuk menggunakan Hasil Tulisan.", CMGm + 4, CMGm
    SetTimer () => ToolTip(), -1500
}

BTC_Click(*) 
{
    global outString
    outString := ATT.Text
    A_Clipboard := outString
    ClipTooltip()
    ResetGUI()
}

Gui_CheckFocus(*) 
{
    global CMGTi
    global CMGVe
    global AutoFill := 1
    global AppMode := "otomatis"
    if WinActive( CMGTi " v" CMGVe )
    {
        AutoFill := 0
        AppMode := "manual"
    }
    CMPM.Text := "Mode: " AppMode
}

Gui_ListClick(*) 
{
    global outString
    global ArTrig
    global ArDesc
    global ArText
        
    ; loop through trigger array -----------------------------
    Loop ArTrig.Length 
    {
        if( ArTrig[ A_Index ] = ATL.Text ) 
        {
            ATS.Text := ArTrig[ A_Index ]
            ATD.Text := ArDesc[ A_Index ]
            ATT.Text := ArText[ A_Index ]
            outString := ArText[ A_Index ]
            break
        }
    }
    AddTrigger()
}

Gui_ListDbClick(*) 
{
    global outString
    global ArTrig
    global ArDesc
    global ArText
        
    ; loop through trigger array -----------------------------
    Loop ArTrig.Length 
    {
        if( ArTrig[ A_Index ] = ATL.Text ) 
        {
            ATS.Text := ArTrig[ A_Index ]
            ATD.Text := ArDesc[ A_Index ]
            ATT.Text := ArText[ A_Index ]
            outString := ArText[ A_Index ]
            break
        }
    }    
    BTC_Click()    
}

Gui_Resettex(*)
{
    global tex := ""
    CML.Text := tex
    Gui_CheckFocus()
}

GuiObjWidth(list, width)
{
    WidthGui := Gui()
    width := 0
    
    ; loop through list array --------------------------------
    Loop list.Length 
    {
        WiGu := WidthGui.Add("Text", "vWiGu" A_Index, list[ A_Index ])
        WiGu.GetPos( , , &WiNu, )
        width := WiNu > width ? WiNu : width
    } 
    WidthGui.Destroy()
    return width + 10
}
